/*
   prevod z WAV: ffmpeg -f s16le -acodec pcm_s16le -i input.wav output.pcm
   ffmpeg -i file.wav -f s16le -ar 48k -acodec pcm_s16le file.raw

   prevod do WAV: ffmpeg -f s16le -ar 48k -ac 2 -i input.pcm output.wav
*/

#define _GNU_SOURCE
#include "stdio.h"
#include "sys/types.h"
#include "unistd.h"
#include "string.h"
#include "stdlib.h"
#include "signal.h"
#include "unistd.h"
#include "fcntl.h"
#include "sys/time.h"

#include <e-hal.h>


#define BUFLEN 12000 // velikost docasnych promennych - odesilani, prijem

#define DEBUG 1

typedef struct {
  int frame_size;
  int sample_rate;
  int channels;
  int application;
  int bitrate;
  int max_frame_size;
  int max_packet_size;
} parameter_list;

typedef struct {
  parameter_list params;
  int file_id;
  int chunk_id;
} encoder_parameters;

typedef struct {
  int opened;
  long filesize;
  char *name;
  struct timeval start_time;
  struct timeval end_time;
} fileinfo;

typedef struct {
  int col;
  int row;
} proc_loc;

char *my_itoa(int val);  //integer na pole znaku
char *basename(char const *path);

void mainloop();

int create_encoders(int number);
int create_decoders(int number);

int row(int process);
int col(int process);

int encode_frame(int16_t *input_frame, encoder_parameters encoder_params);
int decode_frame(unsigned char *input_frame, int input_size, encoder_parameters encoder_params);
int load_frame(FILE *fin, int channels, int frame_size, int16_t *output);
int save_frame(FILE *fout, int channels, int decoded_size, int16_t *out);


void show_progress();

int *core_mem;

void dummy_get_core_mem();
void dummy_start();
void dummy_read();

parameter_list params;
encoder_parameters encoder_params;

char buffer[BUFLEN];

encoder_parameters recv_params;
int recv_size;

   FILE **fin;
   FILE **fout;
   int *chunk;
   int *process_ready;
   proc_loc *process_location;
   fileinfo *file_info;
   int file_id;
   int num_files;

   int16_t in[BUFLEN];
   int16_t out[BUFLEN];

   e_epiphany_t *dev;




int main(int argc, char **argv)
{

  // nastaveni parametru enkoderu

    params.frame_size = 2880;
    params.sample_rate = 48000;
    params.channels=2;
    params.application=2049;  // konstanta pro OPUS_APPLICATION_AUDIO
    params.bitrate=64000;
    params.max_frame_size=2880;
    params.max_packet_size=params.max_frame_size*params.channels;

// inicializace epiphany
e_init(NULL);
e_reset_system();

//num_files=(argc-1)/2;


  // soubory

/*fin=(FILE*)malloc(sizeof(FILE)*num_files);
fout=(FILE*)malloc(sizeof(FILE)*num_files);
chunk=(int*)malloc(sizeof(int)*num_files);
process_ready=(int*)malloc(sizeof(int)*num_files*2);
process_location=(proc_loc*)malloc(sizeof(proc_loc)*num_files*2);
file_info=(fileinfo*)malloc(sizeof(fileinfo)*num_files);
dev=(e_epiphany_t*)malloc(sizeof(e_epiphany_t)*num_files*2);
*/
dev=(e_epiphany_t*)malloc(sizeof(e_epiphany_t)*16);
core_mem=(int*)malloc(sizeof(int)*16);

/*if ((argc<3) || (!(argc % 2))) {printf("Usage: opus_server input1 output1 input2 output2 ... \n");exit(0);}

int i;int y=0;
for (i=1;i<argc;i++)
{
if (DEBUG==1) {printf("Input %d: %s\nOutput %d: %s\n",y,argv[i],y,argv[i+1]); }
fin[y] = fopen(argv[i], "r");
fout[y] = fopen(argv[i+1], "w");
if (fin[y]==NULL){printf("Cannot open %s!\n",argv[i]);}
if (fout[y]==NULL){printf("Cannot open %s!\n",argv[i+1]);}

fseek(fin[y], 0, SEEK_END); // seek to end of file
file_info[y].filesize= ftell(fin[y]); // get current file pointer
fseek(fin[y], 0, SEEK_SET); // seek back to beginning of file

file_info[y].opened=1;
file_info[y].name=basename(argv[i]);

process_ready[i]=0; // pomocna promenna pro zjisteni jestli jsou spustene vsechny enkodery a dekodery
i++;
y++;
}

create_encoders(num_files);
create_decoders(num_files);
*/

  /*
  while(1)
  {
   mainloop();
  }
  */

dummy_start();
//sleep(2000);
dummy_get_core_mem();
dummy_read();

return 0;
}

void dummy_start()
{ 
  printf("starting\n");  
  int i;
  for (i=0;i<=15;i++)
    { printf("opening device %d on [%d,%d]\n",i,row(i),col(i));
      e_open(&dev[i],row(i),col(i),1,1);
      //printf("resetting group\n");
      e_reset_group(&dev[i]);
      //printf("loading dummy.srec\n");
      e_load("opus_encode.srec",&dev[i],0,0,E_TRUE);
      //printf("Started dummy on core %d\n",i);
    }
 printf("starting procedure finished.\n"); 
}

void dummy_get_core_mem()
{   printf("checking cores internal memory offsets..\n");
    e_mem_t emem;
    e_alloc(&emem,0x01000000,sizeof(int)*16);
    printf("getting offsets from cores.. \n");
    e_read(&emem,0,0,0x0,core_mem,sizeof(int)*16);
    int i;
    for(i=0;i<=15;i++)
    {	
    printf("Core %d - readed offset: %d\n",i,core_mem[i]);
    }   
    printf("cores offsets readed.\n");
    e_free(&emem);
}

void dummy_read()
{   printf("starting read..\n");
    char msg[10];
    int i;
    for (i=0;i<=15;i++)
    {  
	if((e_read(&dev[i],0,0,core_mem[i],msg,32))>0)
        {printf("Core #%d: \"%s\" \n",i,msg);
        } else
        {printf("Core #%d: Error!\n",i);
	}	
    }
 printf("reading procedure finished.\n");
}

void mainloop()
{
    // precteni prijateho paketu a dekodovani

//    recvfrom(sock, &buffer, BUFLEN, 0, (struct sockaddr *)&si_other, &slen);

    switch (buffer[0])
    {
      case 'D':{// prisel dekodovany frame - ulozit
                if (DEBUG==1) {printf("server    - Received decoded frame.\n");}
                // ulozeni dat z paketu do promennych
                memcpy(&recv_params, buffer+sizeof(char), sizeof(encoder_parameters));
                memcpy(&recv_size, buffer+sizeof(char)+sizeof(encoder_parameters), sizeof(int));
                int16_t recv_data[recv_size*recv_params.params.channels];
                memcpy(&recv_data, buffer+sizeof(char)+sizeof(encoder_parameters)+sizeof(int), recv_size*recv_params.params.channels*sizeof(int16_t));
                // ulozeni dekodovaneho ramce
                save_frame(fout[recv_params.file_id], recv_params.params.channels, recv_size, &recv_data);
                recv_params.chunk_id=++chunk[recv_params.file_id];
                if (DEBUG==0) {show_progress();}

                // nacteni dalsiho ramce ze souboru a odeslani enkoderu
                if (load_frame(fin[recv_params.file_id], recv_params.params.channels, recv_params.params.frame_size, in))
                {
                 encode_frame(in,recv_params);
                }
                else
                {
                 if (DEBUG==1) {printf("server    - File end - %s\n",file_info[recv_params.file_id].name);}
                 fclose(fin[recv_params.file_id]);
                 fclose(fout[recv_params.file_id]);
                 gettimeofday(&(file_info[recv_params.file_id].end_time), NULL);
                 file_info[recv_params.file_id].opened=0;
                 chunk[recv_params.file_id]++;
                 if (DEBUG==0) {show_progress();}

                 int i;int done=1;
                 for (i=0;i<num_files;i++) {if (file_info[i].opened==1) {done=0;}}
                 if (done==1) {
                   exit(0);
                   //jeste killnout procesy
                   }
                }
      }break;

      case 'E':{// prisel zakodovany frame - dekodovat
                if (DEBUG==1) {printf("server    - received encoded frame.\n");}
                // ulozeni dat z paketu do promennych
                memcpy(&recv_params, buffer+sizeof(char), sizeof(encoder_parameters));
                memcpy(&recv_size, buffer+sizeof(char)+sizeof(encoder_parameters), sizeof(int));
                unsigned char recv_data[recv_size];
                memcpy(&recv_data, buffer+sizeof(char)+sizeof(encoder_parameters)+sizeof(int), recv_size*sizeof(unsigned char));
                // odeslani zakodovanych dat dekoderu
                decode_frame(recv_data,recv_size,recv_params);
      }break;

      case 'S':{// prisly informace o stavu - spusteni enkoderu/dekoderu
                if ((buffer[1])=='D')
                { // ohlasil se dekoder
                  if (DEBUG==1) {printf("Decoder %d ready (process nr.%d).\n",buffer[2],buffer[2]);}
                  process_ready[buffer[2]]=1;
                }
                else if ((buffer[1])=='E')
                { // ohlasil se enkoder
                  if (DEBUG==1) {printf("Encoder %d ready (process nr.%d).\n",buffer[2],(num_files+buffer[2]));}
                  process_ready[num_files+buffer[2]]=1;
                }

                int i;int ready=1;
                for (i=0;i<(num_files*2);i++) {if (process_ready[i]==0) {ready=0;}}
                if (ready==1)
                // nacteni prvniho framu ze souboru a odeslani enkoderu ktery se ohlasil jako ready
                {for (i=0;i<(num_files);i++)
                 {
                  if (load_frame(fin[i], params.channels, params.frame_size, in))
                  {
                    encoder_params.chunk_id=0;
                    encoder_params.file_id=i;
                    encoder_params.params=params;
                    gettimeofday(&(file_info[i].start_time), NULL);
                    //if (DEBUG==0) {show_progress(file_info[(int)buffer[2]],0);}
                    encode_frame(in,encoder_params);
                  }
                 }
                }
      }break;

      default: // neznamy paket
                printf("Received unknown packet!\n");
                //printf("Data: %.*s\n",30,buffer);
                if (DEBUG==1) {printf("RAW data: %02x %02x %02x %02x %02x %02x %02x %02x\n",buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7]);}
               // mohlo by se vypsat napr. prvnich 16 bajtu v cyklu, ale neni nutne zatim.
      break;
    }

}

int create_encoders(int number)
{ // 
  int y;
  for (y=0;y<number;y++)
    {
      // enkodery - jadra 0-7
      e_open(&dev[y],row(y),col(y),1,1);
      e_reset_group(&dev[y]);
      e_load("opus_encode.srec",&dev[y],0,0,E_TRUE);
    }
  
return 1;
}

int create_decoders(int number)
{ // stejne jako create_encoders, ale s dekodery
  int y;
  for (y=0;y<number;y++)
    {
      // dekodery - jadra 8-15
      e_open(&dev[y+8],row(y+8),col(y+8),1,1);
      e_reset_group(&dev[y+8]);
      e_load("opus_decode.srec",&dev[y+8],0,0,E_TRUE);
    }
return 1;    
}


int encode_frame(int16_t *input_frame, encoder_parameters encoder_params)
{ // poslani framu enkoderu - priprava paketu, odeslani
  

  // vlastni struktura paketu - nejprve parametry (typ encoder_parameters), pak samotne data.
  char output_data[BUFLEN];
  memcpy(output_data,&encoder_params,sizeof(encoder_parameters));
  memcpy(output_data+sizeof(encoder_parameters),input_frame,encoder_params.params.frame_size*encoder_params.params.channels*sizeof(int16_t));
//if (DEBUG==1) {printf("server    - chunk #%d - data sent to port %d - id %d\n", encoder_params.chunk_id, PORT_ENCODER+encoder_params.file_id, encoder_params.file_id);}
  //sendto(socketDescriptor_send, output_data, sizeof(encoder_parameters)+(encoder_params.params.channels*encoder_params.params.frame_size*sizeof(int16_t)), 0, (struct sockaddr *) &serverAddress_send, sizeof(serverAddress_send));

  return 1;
}

int decode_frame(unsigned char *input_frame, int input_size, encoder_parameters encoder_params)
{ // stejne jako encode_frame, akorat jina struktura paketu a jiny prijemce
  
  char output_data[BUFLEN];
  memcpy(output_data,&encoder_params,sizeof(encoder_parameters));
  memcpy(output_data+sizeof(encoder_parameters),&input_size,sizeof(int));
  memcpy(output_data+sizeof(encoder_parameters)+sizeof(int),input_frame,input_size*sizeof(unsigned char));
//if (DEBUG==1) {printf("server    - chunk #%d - data sent to port %d - id %d\n", encoder_params.chunk_id, PORT_DECODER+encoder_params.file_id, encoder_params.file_id);}
  //sendto(socketDescriptor_send, output_data, sizeof(int)+sizeof(encoder_parameters)+input_size*sizeof(unsigned char), 0, (struct sockaddr *) &serverAddress_send, sizeof(serverAddress_send));

  return 1;
}

int load_frame(FILE *file, int channels, int frame_size, int16_t *output)
{ // nacteni ramce ze souboru a prevod z 8bit char do 16bit int se kterym pracuje opus
  int i;
  unsigned char pcm_bytes[BUFLEN];

  /*
      myslel jsem ze by slo napr. pro ilustraci nacitat ruzne casti souboru a ty ruzne
      paralelne enkodovat/dekodovat, ale moc dobre to nepujde kvuli zustavajicimu kontextu v
      enkoderu i dekoderu, takze se soubor nacita i uklada postupne, bez chunk_id a seekovani.
  */

  //fseek (file, chunk_id*(sizeof(short)*channels)*frame_size, SEEK_SET );
  //printf("Seek:%d\n",chunk_id*frame_size);
  //printf("Starting fread\n");
  fread(pcm_bytes, sizeof(short)*channels, frame_size, file);
  if (feof(file)) return(0);
  // prevod z little-endian
  for (i=0;i<channels*frame_size;i++)
     output[i]=pcm_bytes[2*i+1]<<8|pcm_bytes[2*i];

  return 1;
}

int save_frame(FILE *file, int channels, int decoded_size, int16_t *out)
{ // ulozeni dekodovaneho ramce do souboru.
  int i;
  unsigned char pcm_bytes[BUFLEN];

  for(i=0;i<channels*decoded_size;i++)
  {
    pcm_bytes[2*i]=out[i]&0xFF;
    pcm_bytes[2*i+1]=(out[i]>>8)&0xFF;
  }

  //fseek (fout, chunk_id*sizeof(short)*channels*decoded_size, SEEK_SET );
  // v pripade seekovani nejprve vyhradit misto v pameti, naplnit, a pak ulozit do souboru.
  // ale asi se to tak delat nebude.

  //printf("Starting fwrite - size %d, channels %d.\n",decoded_size,channels);
  fwrite(pcm_bytes, sizeof(short), channels*decoded_size, file);

  return 1;
}


char *my_itoa(int val)
{
static char buf[32] = {0};
/*	int i = 30 ;
	for(; val&& i ; --i, val /= 10)
		buf[i] = "0123456789abcdef"[val % 10];
	return &buf[i+1];
*/
 sprintf(buf,"%d",val);
 return buf;
}

char *basename(char const *path)
{
    char *s = strrchr(path, '/');
    if (!s) {return strdup(path);} else {return strdup(s + 1);}
}

void show_progress()
{
  int progress;
  int i;int y;
  int done=1;

  for(i=0;i<num_files;i++)
  {
    printf("%s \t\t[",file_info[i].name);
    progress=100*(chunk[i]*params.channels*params.frame_size*sizeof(short))/(file_info[i].filesize);
    for(y=0;y<(progress/5);y++){printf("#");}
    for(y=0;y<(20-(progress/5));y++){printf(" ");}
    printf("] %d%% ",progress);
    if (file_info[i].end_time.tv_usec>0) {printf("\ttime: %fs",(file_info[i].end_time.tv_sec + (1.0/1000000) * file_info[i].end_time.tv_usec)-(file_info[i].start_time.tv_sec + (1.0/1000000) * file_info[i].start_time.tv_usec));} else  {done=0;}
    printf("\n");
  }

 if (done==0) { for(i=0;i<num_files;i++) {printf("%c[A", 27);printf("%c[2K", 27);}}

}

// ktery proces patri na jake jadro

int row(int process)
{
switch(process)
   {
    case 0: case 1: case 2: case 3: return 0;
    case 4: case 5: case 6: case 7: return 1;
    case 8: case 9: case 10: case 11: return 2;
    case 12: case 13: case 14: case 15: return 3;
    default:break;
   }
return -1;
}


int col(int process)
{
switch(process)
   {
    case 0: case 4: case 8: case 12: return 0;
    case 1: case 5: case 9: case 13: return 1;
    case 2: case 6: case 10: case 14: return 2;
    case 3: case 7: case 11: case 15: return 3;
    default:break;
   }
return -1;
}