/*
   prevod z WAV: ffmpeg -f s16le -acodec pcm_s16le -i input.wav output.pcm
   prevod do WAV: ffmpeg -f s16le -ar 48k -ac 2 -i input.pcm output.wav
*/

#include <stdlib.h>
//#include <errno.h>
#include <string.h>
#include "include/opus.h"
#include <stdio.h>

#include "e_lib.h"

#define BUF_SIZE 6000  //pro frame size 2880 to je tak akorat, stacilo by i 11000

int get_process_id();

typedef struct {
  int frame_size;
  int sample_rate;
  int channels;
  int application;
  int bitrate;
  int max_frame_size;
  int max_packet_size;
} parameter_list;

typedef struct {
  parameter_list params;
  int encoder_id;
  int chunk_id;
} encoder_parameters;


int *ext_buffer=(int*)0x8f000000;
char int_buffer[BUF_SIZE];


int main(void)
{
   //char input_data[BUF_SIZE/2];
   //char output_data[BUF_SIZE];
   //char output_ready[3];

   unsigned char in[BUF_SIZE/2];

   OpusDecoder *decoder;

   int err;

   int decoder_created=0;
   int decoded_size;
   int input_size;
   opus_int16 out[BUF_SIZE];


   int decoder_id;
   int process_id;
   //decoder_id=atoi(argv[3]);
   process_id=get_process_id();
   decoder_id=process_id-8;

   encoder_parameters encoder_params;
   parameter_list params;


    // do sdilene RAM poslat udaje o adrese ve vnitrni RAM
    ext_buffer[process_id]=(int)&int_buffer;

    memcpy(int_buffer,"SD",2*sizeof(char));
    memcpy(int_buffer+2*sizeof(char),&decoder_id,sizeof(int));
    //sendto(socketDescriptor_send, output_ready, 2*sizeof(char)+sizeof(int), 0, (struct sockaddr *) &serverAddress_send, sizeof(serverAddress_send));

    while(1) {

    //precist externi RAM, pokud tam bude 2, vzit z interni RAM data
      if (ext_buffer[process_id]==2)
      {
      //recvfrom(socketDescriptor_recv, input_data, MESSAGE_SIZE, 0, (struct sockaddr *)&clientAddress, &clientAddressLength);

        memcpy(&encoder_params,int_buffer,sizeof(encoder_parameters));
        params=encoder_params.params;
        memcpy(&input_size, int_buffer+sizeof(encoder_parameters),sizeof(int));
        memcpy(in, int_buffer+sizeof(int)+sizeof(encoder_parameters),(input_size*sizeof(unsigned char)));

        if (decoder_created==0)
        { decoder = opus_decoder_create(params.sample_rate, params.channels, &err);
          decoder_created=1;
        }

        decoded_size=opus_decode(decoder, in, input_size, out, params.max_frame_size, 0);

        memcpy(int_buffer,"D",sizeof(char));
        memcpy(int_buffer+sizeof(char),&encoder_params,sizeof(encoder_parameters));
        memcpy(int_buffer+sizeof(char)+(sizeof(encoder_parameters)),&decoded_size,sizeof(int));
        memcpy(int_buffer+sizeof(char)+(sizeof(encoder_parameters)+sizeof(int)),out,(decoded_size*params.channels*sizeof(opus_int16)));

        //sendto(socketDescriptor_send, output_data, sizeof(char)+(decoded_size*params.channels*sizeof(opus_int16))+(sizeof(encoder_parameters)+sizeof(int)), 0, (struct sockaddr *) &serverAddress_send, sizeof(serverAddress_send));
        // do itnerni zapsat data, do externi poslat 1
        ext_buffer[process_id]=1;
      }
    }

   return 0;
}

int get_process_id()
{
    unsigned int row;
    unsigned int col;
    e_coreid_t coreid;
    coreid=e_get_coreid();
    col=coreid & 0x3;
    row=(coreid & 0xC0)/64;
    return(((coreid&0xC0)/16)+(coreid&0x3));
}

