/*
   prevod z WAV: ffmpeg -f s16le -acodec pcm_s16le -i input.wav output.pcm
   prevod do WAV: ffmpeg -f s16le -ar 48k -ac 2 -i input.pcm output.wav
*/

#include <stdlib.h>
//#include <errno.h>
#include <string.h>
#include "include/opus.h"
#include <stdio.h>
#include <unistd.h>

#include "e_lib.h"

#define BUF_SIZE 6000  //pro frame_size 2880 to je tak akorat, stacilo by i 11000


int get_process_id();

typedef struct {
  int frame_size;
  int sample_rate;
  int channels;
  int application;
  int bitrate;
  int max_frame_size;
  int max_packet_size;
} parameter_list;

typedef struct {
  parameter_list params;
  int encoder_id;
  int chunk_id;
} encoder_parameters;


volatile int *ext_buffer=(int*)0x8f000000;
volatile char int_buffer[BUF_SIZE];
//char int_buffer[BUF_SIZE] SECTION("data_bank0");

e_mutex_t *mutex;

int main(void)
{
   e_mutex_init(0,0,mutex,NULL);

   opus_int16 in[BUF_SIZE];
   unsigned char cbits[BUF_SIZE/2];
   int nbBytes;
   OpusEncoder *encoder;

   int err;

   int encoder_created=0;


   int encoder_id;
   int process_id;
   //encoder_id=atoi(argv[3]);
   process_id=get_process_id();
   encoder_id=process_id;

    encoder_parameters encoder_params;
    parameter_list params;


    // do sdilene RAM poslat udaje o adrese ve vnitrni RAM
    
    //buffer=(char*)malloc(sizeof(char)*BUF_SIZE);
e_mutex_lock(0,0,mutex);    
ext_buffer[process_id]=(int)&int_buffer;
e_mutex_unlock(0,0,mutex);
    //memcpy(int_buffer,"0123456789ABCDEF",16);
    
    memcpy(int_buffer,"SE",(2*sizeof(char)));
    memcpy(int_buffer+(2*sizeof(char)),&encoder_id,sizeof(int));
    //sendto(socketDescriptor_send, output_ready, (2*sizeof(char))+sizeof(int), 0, (struct sockaddr *) &serverAddress_send, sizeof(serverAddress_send));

    //memset(in, 0, MESSAGE_SIZE);
    //memset(input_data, 0, MESSAGE_SIZE);
    //memset(output_data, 0, MESSAGE_SIZE);


    //test
    unsigned *addr;
    unsigned int led_state;
    

    while(1) {


/*    addr=(unsigned *) (0x6000);
    led_state=(*(addr));
    e_reg_write(E_REG_CONFIG,(unsigned)0x0001000);
    addr=(unsigned *)(0x80AF030c);
    (*(addr))=0x03FFFFFF;
    addr=(unsigned *)(0x80AF0318);
    (*(addr)= ~led_state & 0x00000001);
    e_reg_write(E_REG_CONFIG,(unsigned)0x00400000);    

    addr=(unsigned *) (0x6000);
    led_state=(*(addr));
    e_reg_write(E_REG_CONFIG,(unsigned)0x0001000);
    addr=(unsigned *)(0x80AF030c);
    (*(addr))=0x03FFFFFF;
    addr=(unsigned *)(0x80AF0318);
    (*(addr)= ~led_state & 0x00000001);
    e_reg_write(E_REG_CONFIG,(unsigned)0x00400000);    
*/

      //ext_buffer[process_id]=2;
    
 //precist externi RAM, pokud tam bude 2, vzit z interni RAM data
e_mutex_lock(0,0,mutex);      
      if (ext_buffer[process_id]==2)
      {
    //e_mutex_unlock(0,0,mutex);	

//	ext_buffer[process_id]=1;        
/*       //recvfrom(socketDescriptor_recv, input_data, MESSAGE_SIZE, 0, (struct sockaddr *)&clientAddress, &clientAddressLength);

        memcpy(&encoder_params,int_buffer,sizeof(encoder_parameters));
        params=encoder_params.params;

        memcpy(in, int_buffer+18,(params.frame_size*params.channels*sizeof(opus_int16)));
        // 18 je kvuli int16, sizeof(encoder_parameters) je 36 ale prijata data jsou 16bit.

        if (encoder_created==0)
        {
          encoder = opus_encoder_create(params.sample_rate, params.channels, params.application, &err);
          opus_encoder_ctl(encoder, OPUS_SET_BITRATE(params.bitrate));
          encoder_created=1;
        }

        nbBytes = opus_encode(encoder, in, params.frame_size, cbits, params.max_packet_size);

        memcpy(int_buffer,"E",sizeof(char));
        memcpy(int_buffer+sizeof(char),&encoder_params,sizeof(encoder_parameters));
        memcpy(int_buffer+sizeof(char)+(sizeof(encoder_parameters)),&nbBytes,sizeof(int));
        memcpy(int_buffer+sizeof(char)+(sizeof(encoder_parameters)+sizeof(int)),cbits,(nbBytes*sizeof(unsigned char)));

        //sendto(socketDescriptor_send, output_data, sizeof(char)+(nbBytes*sizeof(unsigned char))+(sizeof(encoder_parameters)+sizeof(int)), 0, (struct sockaddr *) &serverAddress_send, sizeof(serverAddress_send));
        // do itnerni zapsat data, do externi poslat 1
*/
e_mutex_lock(0,0,mutex);
        ext_buffer[process_id]=1;

e_mutex_unlock(0,0,mutex);
      }
    e_wait(E_CTIMER_0,1000*10*1000); // frekvence v mhz * usec -toto je asi 1s
    }

   return 0;
}

int get_process_id()
{
    e_coreid_t coreid;
    coreid=e_get_coreid();
    return(((coreid&0xC0)/16)+(coreid&0x3));
}
